#!/bin/bash

TEMPSMBCONF="/updates/smb.conf"
DATE=`date`

echo "# File: /cluster/config/samba/smb.conf" > $TEMPSMBCONF
echo "# Last changed by exadmin on $DATE" >> $TEMPSMBCONF

echo "[global]" >> $TEMPSMBCONF

function create_global_share() {
	local FIELDS name value
	FIELDS=$(/cluster/config/tools/getparam -c params.protocols.cifs.configuration)

	for field in ${FIELDS} ; do
		name=$(/cluster/config/tools/getparam params.protocols.cifs.configuration.$field.real_name)
		if [ ! -z "$name" ] ; then
			value=$(/cluster/config/tools/getparam params.protocols.cifs.configuration.$field.value)
			if [ -z "$value" ] ; then
				value=$(/cluster/config/tools/getparam params.protocols.cifs.configuration.$field.default_value)
			fi
	
			echo "	$name = $value" >> $TEMPSMBCONF
		fi
	done
}

function create_all_shares() {
	local SHARES share_name field_name path OPTIONS value
	SHARES=$(/cluster/config/tools/getparam -c params.protocols.cifs.shares)

	for share in ${SHARES} ; do
		share_name=$(/cluster/config/tools/getparam params.protocols.cifs.shares.$share.name)
		if [ ! -z "$share_name" ] ; then
			echo "[$share_name]" >> $TEMPSMBCONF
			path=$(/cluster/config/tools/getparam params.protocols.cifs.shares.$share.path)
			if [ ! -z "$path" ] ; then
				echo "	path = $path" >> $TEMPSMBCONF
			fi
			OPTIONS=$(/cluster/config/tools/getparam -c params.protocols.cifs.shares.$share.options)
			for option in ${OPTIONS} ; do
				value=$(/cluster/config/tools/getparam params.protocols.cifs.shares.$share.options.$option.value)
				field_name=$(/cluster/config/tools/getparam params.protocols.cifs.configuration.$option.real_name)
				echo "	$field_name = $value" >> $TEMPSMBCONF
			done
			
		fi

	done
}



create_global_share
create_all_shares


