#!/bin/bash
# Sevices 'root preexec' script

# include /cluster/etc/init.d/functions
. /cluster/etc/init.d/functions

# The IP address of the client machine.
IP=$1

# The relevant service (e.g. smb, afp, etc.)
SERVICE=$2
HOST=`hostname`
NODE=`hostname | cut -d'e' -f2`
if [ ! -L /mnt/${SERVICE}/$IP ] ; then
	# lock the cdb access
	lf_lockwait /mnt/${SERVICE}/root_preexec

 	prevInst=$(getparam params.root_preexec.host.$HOST.rr_count)
	if [ "$?" -ne 0 ]; then
		# create a host
		setparam -a params.root_preexec.host.$HOST
		prevInst=0
	fi
	prevInst=$((prevInst+1))
	instances=$((`getparam params.fs.config.instances`))
	nextInst=$((prevInst % instances))
	# update CDB
	setparam  params.root_preexec.host.$HOST.rr_count $nextInst

	# unlock the cdb access
	lf_unlock /mnt/${SERVICE}/root_preexec

	domain=$(((nextInst*2 + NODE%2) + (NODE/2 * instances*2)))
	ln -sf /mnt/${SERVICE}/${domain} /mnt/${SERVICE}/$IP
fi
#add protocol ident in client record (of arper) in the cdb
IP_ADDR=`echo ${IP} | tr . _`
ClientProtocol=`getparam -q params.networkGroups.clientNetwork.allClients.clients.${IP_ADDR}.protocol`
if [ "$ClientProtocol" != "" ]; then
    #update protocol to latest
    setparam -q params.networkGroups.clientNetwork.allClients.clients.${IP_ADDR}.protocol ${SERVICE}
fi

