#ifndef __LISTENER_MGR
#define __LISTENER_MGR

#include <string>
#include <map>
#include <list>

#include "SambaElmListener.h"
#include "SambaElmConnection.h"


#define DBG(x) if (verbose) {x;}
#define SERVER_PREFIX_SIZE 20

//////////////////////////////////////////////////////
//	Listener Manager								//
//  ------------------								//
// Responsible for all socket handling				//
// listenes and calls the appropriate handler		//
// 													//
// Handles either new connections or existing ones	//
// 													//
// Number of listeners is handles through 			//
// constructor params								//
//////////////////////////////////////////////////////

class ListenerMgr {
public:
	typedef std::map<int,BasicListener *> BasicListenerMap;
	typedef BasicListenerMap::iterator BasicListenerIter;

	typedef std::map<int,BasicConnection *> BasicConnectionMap;
	typedef BasicConnectionMap::iterator BasicConnectionIter;

	typedef std::list<int> RemovalList;
	typedef RemovalList::iterator RemovalListIter;
public:
	ListenerMgr(int baseDomain,
				int step,
				int noOfDomains,
				char *serverPrefix);
	virtual ~ListenerMgr() {};

	void scanFds();

	void open();
	void run();
private:
	int 		_baseDomain;
	int 		_step;
	int 		_noOfDomains;
	std::string _serverPrefix;
	fd_set 		_fdset;
	int 		_maxFd;

	BasicListenerMap 	_listenerMap;
	BasicConnectionMap 	_connectionMap;
	RemovalList 		_removalList;
};

#endif // __LISTENER_MGR

