#ifndef _EXASMB_IF_
#define _EXASMB_IF_

#include "smbutil/exasmb_dlmclient.h"

int32_t exasmb_getsmbid(void);
int32_t exasmb_try_getsmbid( BOOL* is_successful_out );
int exasmb_get_nfs_fh(int fd, unsigned short* len, char nfsfh[64] );
BOOL exasmb_if_initiate_connection(void);
void exasmb_init_cleanup(void);
void register_dlm_cleanup_pid(void);
void exasmb_lock_increase(uint64_t dev, uint64_t inode);
void exasmb_lock_decrease(uint64_t dev, uint64_t inode);
void verify_no_double_lock(uint64_t dev, uint64_t inode);
uint64_t exasmb_get_lock_sequence();

dlm_client exasmb_if_client_open(void);
void exasmb_if_client_close(void);

/* Shared locks */


BOOL exasmb_if_share_lock_lr(char* nfs_fh,unsigned int nfs_fh_len, uint32_t pid, uint16_t tid, uint64_t dev, uint64_t inode, unsigned long share_file_id);
BOOL exasmb_if_share_unlock_lr(char* nfs_fh,unsigned int nfs_fh_len, uint32_t pid, uint16_t tid, uint64_t dev, uint64_t inode, unsigned long share_file_id);
int32_t exasmb_if_share_get_locks(char* nfs_fh, unsigned int nfs_fh_len, uint32_t pid, uint16_t tid, uint64_t dev, uint64_t inode, uint32_t file_id, 
								  struct share_mode_entry **pp_shares, uint32_t num_of_entries, 
								  uint64_t cookie_in, uint64_t *cookie_out, BOOL *delete_on_close);
/* the fsp will always have a valid nfs fh inside */
BOOL exasmb_if_share_add_lock(files_struct *fsp, const struct share_mode_entry *entry);
BOOL exasmb_if_share_delete_lock(files_struct *fsp, const struct share_mode_entry *entry);
BOOL exasmb_if_share_modify_oplock(files_struct *fsp, const struct share_mode_entry *entry);
BOOL exasmb_if_share_set_delete_on_close(files_struct *fsp, BOOL delete_on_close);

/* BRL locks */
/* the fsp will always have a valid nfs fh inside */
BOOL exasmb_if_br_lock_lr(files_struct *fsp);
BOOL exasmb_if_br_unlock_lr(files_struct *fsp);
int32_t exasmb_if_br_get_locks(files_struct *fsp, struct lock_struct **, uint32_t, uint64_t, uint64_t *);
BOOL exasmb_if_br_add_lock(files_struct *fsp, const struct lock_struct *);
BOOL exasmb_if_br_delete_lock(files_struct *fsp, const struct lock_struct *);
BOOL exasmb_if_file_close(files_struct *fsp);

#define PACK_LR_CONTEXT(_pid, _tid, _nfs_fh,_nfs_fh_len, _dev, _inode, _share_file_id, _lr, _err) \
	do { \
	memcpy(_lr.data.buf, _nfs_fh, _nfs_fh_len); \
	_lr.data.len = _nfs_fh_len; \
	_lr.pid = _pid; \
	_lr.tid = _tid; \
	_lr.dev = _dev; \
	_lr.inode = _inode; \
	_lr.file_id = _share_file_id; \
	_lr.sequence_id = exasmb_get_lock_sequence(); \
	} while(0)

#endif

