#ifndef _BASIC_CONNECTION_
#define _BASIC_CONNECTION_

#include "exasmb_types.h"

#define DBG(x) if (verbose) {x;}

extern bool verbose;

//////////////////////////////////////////////
// Basic Connection							//
// --------------------						//
// The basis for the Samba Elm Connection	//
// handle a message											//
//////////////////////////////////////////////

typedef uint32_t *(*xdr_func)(void *, void *);

enum {
	CONN_TYPE_DIRECT,
	CONN_TYPE_REMOTE,
};

class BasicConnection {
public:
	BasicConnection(int fd);

	virtual ~BasicConnection() {};
	virtual exasmb_message_error handleMessage() = 0;

	virtual void send(int len, uint32_t *ctrl_buf);

private:
	BasicConnection(const BasicConnection &other) {}; // disallow usage

protected:
	// Data Members
	int _fd;						// the connection fd
};

#endif /* _BASIC_CONNECTION_ */


