#include <iostream>
#include <string.h>

#include <errno.h>

#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>

#include "BasicListener.h"
#include "exasmb_types.h"


	using namespace std;

	BasicListener::BasicListener(std::string &portName) 
	: _portName(portName)
	, _socket(-1)
	{
	}

	BasicListener::BasicListener(char *portName) 
	: _portName(portName)
	, _socket(-1)
	{
	}

	// listen on the port for new connections
	int BasicListener::open() {

        struct sockaddr_un addr;

		// create new unix socket
        ::memset(&addr, 0, sizeof(addr));
        addr.sun_family = AF_LOCAL;
        ::sprintf(&addr.sun_path[1], "%s", _portName.c_str());
        _socket = socket(PF_UNIX, SOCK_STREAM, 0);

		// calc len of addr
		int len = SUN_LEN(&addr);
		if (!addr.sun_path[0]) {
			len += strlen(&addr.sun_path[1]) + 2;
		}

		// bind
        while (bind( _socket, (struct sockaddr *)&addr, len) < 0) {
                if (errno == EINTR) {
                        cerr << "bind on " << &addr.sun_path[1] << " failed with EINTR... trying again" << endl;
                        continue;
                }
				cerr << "bind on " << &addr.sun_path[1] << " failed with " << errno << "... trying again" << endl;
                //throw std::exception("bla");
        }

		// listen
        if (listen(_socket, 5)) {
			cerr << "listen on " << &addr.sun_path[1] << " failed with " << errno << "... trying again" << endl;
            // throw std::exception("bla");
        }
		DBG(cout << "bind and listen on " << &addr.sun_path[1] << " complete" << endl);

		return _socket;
	}

	// accept new connection
	int BasicListener::newConnection() {

		union {
			struct sockaddr_in inaddr;
			struct sockaddr_un unaddr;
		} addr;
		socklen_t addrlen;
		addrlen = sizeof(addr);
		int newfd = -1;

		newfd = accept(_socket, (struct sockaddr *) &addr, &addrlen);
		return newfd;
	}

