#ifndef	EXASMB_DLMCLIENT_H
#define	EXASMB_DLMCLIENT_H

#include "exasmb_xdr.h"

#ifdef	EXASMB_DLMCLIENT_SOURCE
typedef struct exasmb_dlm_client *dlm_client;
#else
typedef struct exasmb_dlm_client const *dlm_client;
#endif

#ifdef	__cplusplus
extern "C" {
#endif

 
/* set_alarm function gets two functions pointer 
	the first function pointer gets as a parmater a function pointer as well
	the second gets a void parameter
*/
void exasmb_dlm_set_alarm_funcs(void (*arm_alarm_ptr)(void (*callback)(void)),
				void (*disarm_alarm_ptr)(bool),
				void (*trigger_timeout)(int),int trigger_period);

dlm_client
exasmb_dlm_client_create(int domain);

exasmb_message_error
exasmb_dlm_client_destroy(dlm_client);

exasmb_message_error
exasmb_connect(dlm_client, exasmb_connect_request *);

exasmb_message_error
exasmb_cleanup(dlm_client, exasmb_cleanup_request *);

void *
exasmb_dlm_client_get_req_buf(dlm_client, size_t);

void
exasmb_dlm_client_release_req_buf(dlm_client, void *);

/******************************************************************************/
/*          					Shared locks                                  */
/******************************************************************************/

exasmb_message_error
exasmb_share_lock_lr(dlm_client, exasmb_share_lock_lr_request *);

exasmb_message_error
exasmb_share_unlock_lr(dlm_client, exasmb_share_lock_lr_request *);

exasmb_message_error
exasmb_share_get_locks(dlm_client, exasmb_share_get_locks_request *,
						exasmb_share_get_locks_reply *);

exasmb_message_error
exasmb_share_add_lock(dlm_client, exasmb_share_add_lock_request *);

exasmb_message_error
exasmb_share_delete_lock(dlm_client, exasmb_share_delete_lock_request *,
						exasmb_share_delete_lock_reply *);

exasmb_message_error
exasmb_share_delete_lock_by_pid(dlm_client,
						exasmb_share_delete_lock_by_pid_request *);

exasmb_message_error
exasmb_share_set_delete_on_close(dlm_client, exasmb_share_set_delete_on_close_request *);

exasmb_message_error
exasmb_share_modify_oplock(dlm_client, exasmb_share_modify_oplock_request *);

exasmb_message_error
exasmb_share_get_delete_on_close(dlm_client, exasmb_share_get_delete_on_close_request *, exasmb_share_get_delete_on_close_reply *);


/******************************************************************************/
/*                              Byte Range locks                              */
/******************************************************************************/

exasmb_message_error
exasmb_br_lock_lr(dlm_client, exasmb_br_lock_lr_request *);

exasmb_message_error
exasmb_br_unlock_lr(dlm_client, exasmb_br_unlock_lr_request *);

exasmb_message_error
exasmb_br_get_locks(dlm_client, exasmb_br_get_locks_request *,
						exasmb_br_get_locks_reply *);

exasmb_message_error
exasmb_br_chk_lock(dlm_client, exasmb_br_chk_lock_request *);

exasmb_message_error
exasmb_br_add_lock(dlm_client, exasmb_br_add_lock_request *);
						
exasmb_message_error
exasmb_br_delete_lock(dlm_client, exasmb_br_delete_lock_request *);
						

/******************************************************************************/
/*                              Files close                              */
/******************************************************************************/

exasmb_message_error
exasmb_file_close(dlm_client, exasmb_file_close_request *);


#ifdef	__cplusplus
}
#endif

#endif // EXASMB_DLMCLIENT_H
