#ifndef	EXASMB_VFSFSCLIENT_H
#define	EXASMB_VFSFSCLIENT_H

#ifdef	__cplusplus
extern "C" {
#endif

typedef char EXA_NFS_FH[32];

ssize_t exasmb_vfs_sendfile(int tofd, const EXA_NFS_FH fh, int64_t offset, size_t count, int id);
ssize_t exasmb_vfs_shwrite(int shmid, const EXA_NFS_FH fh, off_t offset, size_t buff_offset, size_t count, int id, 
						   int *id_must_exist, int unstable_flag, bool update_mtime);
ssize_t exasmb_vfs_read(const  EXA_NFS_FH nfs_fh, int shmid, int64_t offset, size_t count, int id);
ssize_t exasmb_vfs_rename(const EXA_NFS_FH nfs_fh, const char *from_name, const char *to_name);
ssize_t exasmb_vfs_fsync(const EXA_NFS_FH fh, int id);
int exasmb_vfs_dirplus(int shmid, size_t shmsize, const EXA_NFS_FH fh, uint64_t *cookie);
uint32_t exasmb_vfs_get_snap_id(const EXA_NFS_FH fh);
int exasmb_get_snapshots_timestamps( const char* volume_name, 
									 uint32_t max_number_of_snapshots,
									 uint32_t snapshots_timestamps[],
									 uint32_t* number_of_snapshots );
int exasmb_get_snapshot_name_by_timestamp( const char* volume_name,
										   uint32_t snapshot_timestamp,
										   int* snapshot_found,
										   char snapshot_name[] );

int exasmb_get_antivirus_info( const char* nfs_fh_data, 
							   uint32_t nfs_fh_len, 
							   uint32_t* p_val_out );
int exasmb_set_antivirus_info( const char* nfs_fh_data, 
							   uint32_t nfs_fh_len, 
							   uint32_t val );
int exasmb_set_antivirus_info_guarded( const char* nfs_fh_data, 
									   uint32_t nfs_fh_len, 
									   uint32_t val, 
									   uint32_t guard, 
									   uint32_t* p_info_out );

int exasmb_vfs_statfs(const EXA_NFS_FH fh, uint64_t *bsize, uint64_t *dfree, uint64_t *dsize);
int exasmb_vfs_set_create_time(const EXA_NFS_FH fh, uint32_t create_time_sec, uint32_t create_time_nsec);

struct sid_struct;
#ifndef sid_struct
typedef struct sid_struct sid_struct;
#endif
char* exasmb_vfs_sid_to_string( const sid_struct* p_sid_struct, char* buffer, uint32_t buffer_size );
int exasmb_vfs_map_sid_to_temp_id( const sid_struct* p_sid, uint32_t* p_temp_id_out );
int exasmb_vfs_map_temp_id_to_sid( uint32_t temp_id, sid_struct* p_sid_out );


enum vfs_errnos {
    VFS_FATAL_ERROR = -2,
    VFS_OPERATION_FATAL_ERROR = -3,
    VFS_CLIENT_DISCONNECTED_ERROR = -4,
    VFS_UNEXPECTED_ERROR = -5,
    VFS_UNKNOWN_REQUEST_TYPE = -6,
    VFS_INTERNAL_FS_PROBLEM = -7,
    VFS_READ_ERROR = -8,
    VFS_WRITE_ERROR = -9,
    VFS_PERM_DENIED = -10,
	VFS_NOT_SUPPORTED = -11
};

#ifdef	__cplusplus
}
#endif

#endif // EXASMB_VFSFSCLIENT_H
