#ifndef UNIXNTACL_H
#define UNIXNTACL_H

#include <stdint.h>

#ifdef	__cplusplus
extern "C" {
#endif

#define GROUPS_PER_USER 900 /* In order to fit in 4KB in the message. Can be increased a little more. Windows limits login to 1000 SIDs */

/* Use maximal string legth suitable for VFS RPC calls (not more that 4K in a call)*/
#define MAX_ACCESS_DETAILS_STR_LEN (1024*3-1)
#define EMPTY_DETAILS_STR(str) (str[0]=0,str) /* Use operator comma to reset string and return it in once */
#define IS_DETAILS_NONEMPTY(str) (str!=NULL && str[0]!=0)

typedef enum {
	GRANTED_ACCESS_NOT_ENOUGH = 0,
	MISSED_BITS = 1,
	OPEN_MODE_CONFLICT = 2
} proto_sup_access_denied_msg_type;


typedef enum {
	ACCESS_ALLOWED_ACE_TYPE = 0,
	ACCESS_DENIED_ACE_TYPE = 1
}  ace_type;

typedef enum {
	unknown_trustee = 0,
	trustee_user = 1,
	trustee_group = 2,
	trustee_world = 3,
	trustee_owner = 4,
	trustee_owner_group = 5
}  trustee_type;

struct unixntacl_acl_ace
{
	ace_type	type;
	uint32_t	flags;
	uint32_t	mask;
	struct trustee {
		uint32_t		id;
	} trustee;
};
typedef struct unixntacl_acl_ace unixntacl_acl_ace;
typedef unixntacl_acl_ace unixntacl_acl_allowed_ace;
typedef unixntacl_acl_ace unixntacl_acl_denied_ace;

struct unixntacl_acl
{
	uint32_t type;
	uint32_t ace_count;
	unixntacl_acl_ace *aces;
};

typedef struct unixntacl_acl unixntacl_acl;


#ifdef	__cplusplus
}
#endif

#endif // #ifndef UNIXNTACL_H

