#ifndef XNT_ERROR_LOGGING_H
#define XNT_ERROR_LOGGING_H

#ifdef XNT_ERROR
#undef XNT_ERROR
#endif

#ifdef XNT_DEBUG
#undef XNT_DEBUG
#endif

#ifdef XNT_TRACE
#undef XNT_TRACE
#endif

#ifdef XNT_HERE
#undef XNT_HERE
#endif

#ifdef XNT_WARN
#undef XNT_WARN
#endif

#	include <iostream>

#ifdef XNT_USING_STD_CERR

#define PRINT_WARN(x) {	\
	std::cerr << "[" <<	\
	getpid() << "] " <<	\
	__FILE__  << ":" <<	\
	__LINE__ << ":" <<	\
	__FUNCTION__  << ":" << \
	x << std::endl; }
#endif

#if 1

#	define XNT_ERROR(x) ((void) 0)
#	define XNT_DEBUG(x) ((void) 0)
#	define XNT_TRACE(x) ((void) 0)
#	define XNT_HERE ((void) 0)
#	define XNT_WARN(x) ((void) 0)

#else

#ifdef XNT_USING_STD_CERR

#define XNT_ERROR(x) PRINT_WARN(x)
#define XNT_DEBUG(x) PRINT_WARN(x)
#define XNT_TRACE(x) PRINT_WARN(x)
#define XNT_HERE	 PRINT_WARN(" in")
#define XNT_WARN(x)	 PRINT_WARN(x)

#else // XNT_USING_STD_CERR

#	include <sstream>

#define	XNT_DEBUG(x) \
do { \
	std::stringstream __strm; \
	__strm << \
	__FILE__ << ":" << \
	__FUNCTION__ << "(" << \
	__LINE__ << "): " << x << std::endl; \
	write(2, __strm.str().c_str(), __strm.str().size()); \
} while (0)

#	define XNT_ERROR(x) XNT_DEBUG(x)
#	define XNT_TRACE(x)	XNT_DEBUG(x)
#	define XNT_HERE 	XNT_DEBUG(" in")
#	define XNT_WARN(x)	XNT_DEBUG(x)

#endif // XNT_USING_STD_CERR

#endif


#endif // XNT_ERROR_LOGGING_H
